/* 
 * linuxasm.S -- a quick linux asm hack
 * This code is Copyright (C)2002 Nathan Laredo
 * May be freely distributed in unmodified form
 */
#include <asm/unistd.h>
.text
.global _start
_start:
	/* note that linux clears eax, ebx, ecx, edx on program entry */
	/* direction flag is also cleared by default */
	call print
	.asciz "nil\n"
print:	/* print the string pointed to by the top of the stack */
	popl %edx
	decl %ecx
	movl %edx, %edi
	repnz
	scasb
	movl %edx, %ecx
	subl %edx, %edi
	movl %edi, %edx
	decl %edx
        movb $__NR_write,%al
	int  $0x80
	xorl %ebx, %ebx
	movb $__NR_exit,%al
	int  $0x80
